// -*- mode:C++; tab-width:8; c-basic-offset:2; indent-tabs-mode:t -*-

/* Originally from:
 * http://stackoverflow.com/questions/7870498/using-declaration-in-variadic-template/
 */

template <typename ReturnType, typename Lambda1>
struct lambda_visitor : public Lambda1 {
  using Lambda1::operator();
  lambda_visitor(Lambda1 l1) 
    : Lambda1(l1)
    {}
};

int main() {
  struct T {};
  auto x = [&]() {
    auto tl = [&](const T&) {};
    auto n = lambda_visitor<void, decltype(tl)>(tl);
  };
}
